package com.cpop.api.cloudDb.handler;

import com.alibaba.fastjson.JSONObject;
import com.cpop.api.cloudDb.core.constant.CloudDbUrl;
import com.cpop.api.cloudDb.core.dto.CloudClassDto;
import com.cpop.api.cloudDb.core.dto.CloudStaffDto;
import com.cpop.common.utils.StringUtils;
import com.cpop.core.base.exception.UtilException;
import com.mybatisflex.core.paginate.Page;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Component;
import org.springframework.web.client.RestTemplate;

import java.util.List;

/**
 * 云员工工具类
 * @author DB
 * @version 1.0.0
 * @since 2024-01-10 11:29
 */
@Component
public class CloudStaffHandler {

    @Autowired
    private RestTemplate restTemplate;

    /**
     * 获取班级分页
     * @author DB
     * @since 2024/1/9
     * @param pageNum 分页参数
     * @param pageSize 分页参数
     * @param startDate 开始日期
     * @param endDate 结束日期
     * @param storeId 云校区id
     * @param staffId 员工id
     * @return Page<CloudCustomerDto>
     */
    public Page<CloudStaffDto> getStoreStaffPage(Integer pageNum, Integer pageSize, String startDate, String endDate, String storeId, String staffId) {
        JSONObject jsonBody = new JSONObject();
        jsonBody.put("_type", "staff");
        //分页参数
        jsonBody.put("page", pageNum);
        jsonBody.put("limit", pageSize);
        //开始日期结束日期
        if (StringUtils.isNotBlank(startDate) && StringUtils.isNotBlank(endDate)) {
            jsonBody.put("startTime", startDate);
            jsonBody.put("endTime", endDate);
        }
        if (StringUtils.isNotBlank(staffId)){
            jsonBody.put("staffId", staffId);
        }
        //校区id
        jsonBody.put("storeId", storeId);
        JSONObject jsonObject = restTemplate.postForObject(CloudDbUrl.DATA_CLOUD, jsonBody, JSONObject.class);
        Page<CloudStaffDto> page = Page.of(pageNum, pageSize);
        if (jsonObject != null) {
            if (jsonObject.getBoolean("success")) {
                List<CloudStaffDto> courseDtoList = jsonObject.getJSONArray("list").toJavaList(CloudStaffDto.class);
                page.setRecords(courseDtoList);
                page.setTotalPage(jsonObject.getInteger("total"));
                page.setTotalRow(jsonObject.getInteger("total"));
                return page;
            } else {
                throw new UtilException(jsonObject.getString("error"));
            }
        } else {
            return page;
        }
    }
}
